var _ = require('../util')
var templateParser = require('../parse/template')
var transition = require('../transition')

module.exports = {

  isLiteral: true,

  bind: function () {
    var el = this.el
    this.start = document.createComment('v-partial-start')
    this.end = document.createComment('v-partial-end')
    if (el.nodeType !== 8) {
      el.innerHTML = ''
    }
    if (el.tagName === 'TEMPLATE' || el.nodeType === 8) {
      _.replace(el, this.end)
    } else {
      el.appendChild(this.end)
    }
    _.before(this.start, this.end)
    if (!this._isDynamicLiteral) {
      this.compile(this.expression)
    }
  },

  update: function (id) {
    this.teardown()
    this.compile(id)
  },

  compile: function (id) {
    var partial = this.vm.$options.partials[id]
    _.assertAsset(partial, 'partial', id)
    if (!partial) {
      return
    }
    var vm = this.vm
    var frag = templateParser.parse(partial, true)
    var decompile = vm.$compile(frag)
    this.decompile = function () {
      decompile()
      transition.blockRemove(this.start, this.end, vm)
    }
    transition.blockAppend(frag, this.end, vm)
  },

  teardown: function () {
    if (this.decompile) {
      this.decompile()
      this.decompile = null
    }
  }

}